package net.minecraft.src;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

import net.minecraft.client.Minecraft;

public class ItemResidentsList extends Item
{
    public static String texturePng = "/Nameplate/icon_residentslist.png";

    public ItemResidentsList(int id)
    {
        super(id);
        this.maxStackSize = 1;
    }

    public String getItemNameIS(ItemStack itemstack)
    {
        return "item.residentslist";
    }

    public ItemStack onItemRightClick(ItemStack item, World world, EntityPlayer player)
    {
        // Nameplateを近い順に並べる
        ArrayList<EntityNameplate> nameplateListDistance = (ArrayList<EntityNameplate>)(mod_Nameplate.NameplateList.clone());
        Collections.sort(nameplateListDistance, new NameplateDistanceComparator(player));
        
        Iterator<EntityNameplate> var1 = nameplateListDistance.listIterator();
        
        player.addChatMessage("Residents list:");
        while(var1.hasNext())
        {
            EntityNameplate nameplate = var1.next();
            if(nameplate.entityOwner == null) continue;
            player.addChatMessage(String.format(
                "[%s] %s dist:%.3f x:%.0f y:%.0f z:%.0f",
                new Object[] {
                    nameplate.ownerClass,
                    nameplate.petName,
                    player.getDistanceToEntity(nameplate.entityOwner),
                    nameplate.entityOwner.posX,
                    nameplate.entityOwner.posY,
                    nameplate.entityOwner.posZ
                }
            ));
        }
        return item;
    }
}

class NameplateDistanceComparator implements java.util.Comparator {
    EntityPlayer player;

    public NameplateDistanceComparator(EntityPlayer parPlayer)
    {
        player = parPlayer;
    }

    public int compare(Object s, Object t) {
        EntityLiving so = ((EntityNameplate) s).entityOwner;
        EntityLiving to = ((EntityNameplate) t).entityOwner;
        if(so == null && to == null) return 0;
        else if(so == null) return 1;
        else if(to == null) return -1;
        return (int)(Math.ceil(player.getDistanceToEntity(so) - player.getDistanceToEntity(to)));
    }
}
